## 第三方组件库扩展

除了 React Native 官方提供的组件，团队一般都会有自己的UI组件库。

此外，有很多优秀的第三方组件比如：[ScrollableTabView](https://github.com/ptomasroos/react-native-scrollable-tab-view)， [ViewPager](https://github.com/race604/react-native-viewpager)等，如何把使用了这些组件的 React Native 应用转化为微信小程序呢？

现阶段，Alita并不会去处理项目中的：node_modules目录，所以这些非官方的组件需要手动处理。

我们提供了两种方式：

1. [alita命令转化](./第三方组件库扩展-命令转化.md)， 参考[HelloWorldRN](https://github.com/areslabs/alita/tree/master/examples/HelloWorldRN)里 `@areslabs/hello-rn`包的使用
2. [手动对齐](./第三方组件库扩展-手动对齐.md)， 参考[HelloWorldRN](https://github.com/areslabs/alita/tree/master/examples/HelloWorldRN)里 `@areslabs/hi-rn`包的使用

对于纯JS的组件，我们推荐使用第一种方式，而当组件是平台相关的原生组件的时候，推荐使用第二种方式，另外：第二种方式对齐的组件在性能上有一些优势。

随着你所使用的第三方组件库越来越趋于稳定，这些扩展的工作将会越来越少。另外，alita本身也在探索自动处理的方案。

`react-native`官方的所有组件，都是通过[手动对齐](./第三方组件库扩展-手动对齐.md)，预先已经处理好了，也可以参考其[源码](https://github.com/areslabs/alita/tree/master/packages/wx-react-native) 












